-[ c library "fileio.c", header "fileio.h" ]

+[ system headers ]
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
+[ end ]


-[public] char* file_read_all(char *fn) {
	size_t L;
	struct stat sb;
	FILE *f;
	char *buf= 0;
	int total;
	if (stat(fn,&sb))
		return 0;
	f= fopen(fn,"rb");
	if (!f)
		return 0;
	L= sb.st_size;
	buf= malloc(L+1);
	if (!buf)
		goto done;
	total= 0;
	while(total<L) {
		size_t r= fread(buf + total, 1, L-total, f);
		if (!r) {
			free(buf);
			buf= 0;
			break;
		}
		total += r;
	}
	buf[L]= 0;
done:
	fclose(f);
	
	return buf;
}
