Section("jjdoc");
Heading3("JJ \072 The Builder");
PBreak();
Code("jj");
Text(" is a ");
Code("make");
Text(" replacement\056 ");
Text("It works in pretty much the same way\054\012but it fixes some of the things done wrongly in make\056");
ListBegin(1);
ListItem(1);
Text(" ");
Text("It has proper support for multiple targets being generated by one command\056\012GNU make normally runs a command multiple times if multiple output files\012generated by the same command is out\055of\055date\056");
ListItem(1);
Text(" ");
Text("It supports GNU make\047s VPATH feature in a more generic way\056");
ListItem(1);
Text(" ");
Text("It allows user to define new functions which makes it easier to build\012lots of similar files\056 Unlike in make\054 you can have many types of ");
Text("C\012files each with their own rules\056");
ListEnd(1);
Text("\012Unlike make\054 jj does not include any pre\055defined commands to build files\056\012You need to define how to build a file using ");
Code("commands");
Text("\056 A command is an\012object with three important fields\072 ");
Code("triggers");
Text("\054 ");
Code("action");
Text(" and ");
Code("outputs");
Text("\056\012");
Text("When you create a command with these fields\054 jj looks at the files in\012the triggers field and runs the action\054 hopefully producing the outputs\056\012");
Text("Let\047s see a simple example\054 ");
Text("C compilation");
Verbatim("  \173\012    \173\0440\0560\175 \173\056c\175 \173\056o\175 \173\044output\175 rep\056sfx\012    \173\044id\175 cmd\056new\012    \173\044id\175 \173\012      triggers \173\0440\175 \012      sources \173\0440\175 \012      outputs \173\044output\175\012      flags \173\0441\175\012      action \173gcc \055o \044output \055c \044sources \055Wall \055g \044flags\175\012      message \173Compiling \044sources\175\012    \175 cmd\056set\012  \175 \173compile\175 def\012  \012  \173parser\056c\175 \173\175 compile\012");
Text("As you can see a postfix notation is used for defining and using the functions\056\012");
Text("In the last line\054 we call our function ");
Code("compile");
Text(" with two arguments\054 a list\012consisting of one file \050parser\056c\051 and an empty list\056 ");
Text("Whenever you call a \012function\054 arguments have to be in list notation\054 enclosed in curly brackets\056\012Otherwise\054 jj would interpret the argument as a function name and try to call\012it\056");
PBreak();
Text("In the first line of the function\054 we transform the input name to the output\012name using the ");
Code("rep\056sfx");
Text(" function\056 ");
Text("It replaces the suffix as you can imagine\056");
PBreak();
Code("rep\056sfx");
Text("\072 4 arguments\056");
ListBegin(1);
ListItem(1);
Text(" The input value\056");
ListItem(1);
Text(" The old suffix to be replaced\056 ");
Text("If one of the values in the input list\012doesn\047t have this suffix\054 it will be passed as it is\056");
ListItem(1);
Text(" The new suffix\056");
ListItem(1);
Text(" The name of the variable to store the result\056");
ListEnd(1);
Text("\012This function transforms the strings in the first argument by removing the\012old suffix and appending the new suffix\056 ");
Text("It then stores these strings in the\012given variable as a list\056");
PBreak();
Text("The first argument in this call looks rather strange\072 ");
Code("\0440\0560");
Text("\056 This is a \012positional parameter and represents the first argument in the call\056 ");
Text("In our\012case\054 it expands to ");
Code("parser\056c");
Text("\056 Positional parameters are represented\012as ");
Code("\044N");
Text(" where N is a non\055negative integer\056 There is no upper or lower limit\012on the number of arguments a function can take\056 So\054 the proper way to\012address the first positional parameter would be ");
Code("\0440");
Text("\056 However\054 we want \012only the first item of the list\054 that is ");
Code("\0440\0560");
Text("\056 The second item of this\012list would be ");
Code("\0440\0561");
Text(" and so on\056 Please note that addressing items of lists\012in this way can only be done for positional parameters and not variables\056");
PBreak();
Text("Anyway\054 second and third arguments are simple strings\056 Note that jj is space\055\012insensitive\056 ");
Text("We could just as well have written");
Verbatim("  \173\0440\0560\175  \173\012       \056c \175\173\056o        \175 \173\044output\175 rep\056sfx\012");
Text("White space is important to separate items of a list from each other\056 Other\012than that\054 it has no value and is discarded after parsing\056");
PBreak();
Text("The fourth argument is the name of a variable\054 ");
Code("\044output");
Text("\056 ");
Text("Lowercase\012identifiers refer to local variables accessible only in the function they are\012defined in\056 Uppercase identifiers refer to global variables\056 All variable names\012start with the \047\044\047 character\056 ");
Text("It doesn\047t matter whether you\047re accessing it\012or setting it\056");
PBreak();
Text("Finally\054 rep\056sfx is the name of the function\056 Function names can have any\012number of funny punctuation characters in them\054 lest they be left or right\012curly braces\056 Function names are case sensitive though\056 Now we create a\012command using the ");
Code("cmd\056new");
Text(" function\056");
PBreak();
Code("cmd\056new");
Text("\072 1 argument");
ListBegin(1);
ListItem(1);
Text(" The name of the variable to store the handle for the command\056");
ListEnd(1);
Text("\012This function creates a new command and stores the handle for the command\012in the given variable\056 The handle is a simple integer\056 You can later use this\012handle to modify the contents of the command\054 as shown below\056");
PBreak();
Code("cmd\056set");
Text("\072 2 arguments");
ListBegin(1);
ListItem(1);
Text(" The handle of the command\056");
ListItem(1);
Text(" A list of assignment pairs\056");
ListEnd(1);
Text("\012This function finds the command with the given id and sets its fields as\012given in the second argument\056 For the example above\054 ");
Verbatim("   \173\044id\175 \173\012      action \173gcc \055o \044output \055c \044sources \055Wall \055g \044flags\175\012   \175 cmd\056set\012");
Text("sets the ");
Code("action");
Text(" field of the command to the string in curly braces\056\012The action field is one of the special fields for jj\056 ");
Text("In\012this field\054 we see two variable references\072 ");
Code("\044output");
Text(" and ");
Code("\044flags");
Text("\056 These\012are not defined anywhere\054 where do they get their values\077 The answer is\072 the\012command object\056 ");
Text("If the ");
Code("message");
Text(" or ");
Code("action");
Text(" fields of a command object\012contains unresolved variable references\054 jj tries to resolve the reference\012by looking at the fields of the command\056 For the above example\054 the value\012of the ");
Code("flags");
Text(" field is inserted in its place when it\047s time to run the\012action\056 This has several advantages\056 For instance\054 you can modify the\012fields of a command after you\047ve defined it\056 ");
Italic("However\054 a way to access the\012current value of a command is missing for now\056 I\047ll implement it later\056");
PBreak();
Text("There are two more mandatory fields in a command\072 triggers and outputs\056 jj \012decides whether or not to run a command by looking at the modification times of\012the files given in these fields\056 ");
Text("If outputs or triggers are not available for\012a command\054 it will always run\056");
PBreak();
Text("Another field in the command object is the ");
Code("message");
Text("\056 ");
Text("If you set this field\012for your commands and then run jj with the ");
Code("\055m");
Text(" option\054 then jj will print\012the message instead of displaying the command it\047s executing\056 For the above\012example\054 the console output of jj would be\072");
Verbatim("  jj\072 Compiling parser\056c\012");
Text("Anyway\054 the last two lines of the function definition makes the function\012available\056 ");
Verbatim("   \175 \173compile\175 def\012");
Text("The ");
Code("def");
Text(" function takes a body and a name as an argument and places the\012function in the function table\056");
PBreak();
Heading4("Predefined Variables");
PBreak();
Text("TODO\072 explain \044HE");
Text("RE and \044");
Text("C");
Text("WD here\056");
PBreak();
Heading4("Other Functions");
PBreak();
Text("list\056trans  str\056cat \173print\057dump\057dump\056cmd\175 include set eval comment");
PBreak();
Text("I need a method of obtaining a program\047s output\056 ");
Text("Like the backtick\012operator in shell\056 ");
Text("I could then use this to make things like");
Verbatim("  \173freetype\055config \055\055libs\175 \173\044FreeTypeLibs\175 getprgout\012");
Text("This is now done\056 The ");
Code("prgout");
Text(" function works like this\072");
Verbatim("  \173\044LIBS\056freetype\175 \173pkg\055config\175 \173\055\055libs\175 \173freetype2\175 prgout\012");
Text("The function interprets the first argument as the variable\012name to store the result\056 The rest of the arguments\012build up the ");
Code("argv");
Text(" vector\056 The program is then\012executed directly \050i\056e\056 ");
Code("execvp");
Text("\051 and the output is\012put into the given variable\056 Variables are allowed in the\012argument specifications\056");
PBreak();
PBreak();
Heading3("TODO");
PBreak();
Text("rep\056sfx should be just like str\056cat\056 ");
Text("It should return a value\012instead of setting the variable itself\056 Although it does work\012for both lists and strings\054 the str\056cat approach is more elegant\056");
PBreak();
Text("I need to clean up the code a lot\056 There are some things that\012could be done inside functions\056");
PBreak();
Text("I need a way to check conditions\056 ");
Text("Like");
Verbatim("  \173 code \175 \173variable value\175 ifeq\012");
Text("or something\056");
PBreak();
Text("I need to access environment variables from within jj\056 setenv\050\051 would\012also be a good addition\056");
PBreak();
Text("I need some standard libraries to compile\054 generate ");
Text("C code etc\056 ");
Text("Copying\012from place to place isn\047t nice\056");
PBreak();
Text("I need a way of determining which command is responsible for generating\012a given output file\056");
PBreak();
Text("Better argument checking\056 For instance\054 ");
Text("I got confused and made this\072");
Verbatim("  \173\044id\175 \173\012    stuff\012  \175 cmd\056new\012");
Text("instead of");
Verbatim("  \173\044id\175 cmd\056new\012  \173\044id\175 \173\012      stuff\012  \175 cmd\056set\012");
Text("Of course\054 ");
Text("I ended up with an empty command that does nothing\056");
PBreak();
Text("I need a way to specify phony targets that don\047t exist as a file on disk\056");
PBreak();
Text("I need to make a filter in order to run only the commands that play a role\012in generating a given target\056 For instance\054 if ");
Text("I need only one executable\012and not the whole set of outputs\054 ");
Text("I should be able to do\072");
Verbatim("  jj \055t mex\012");
Text("or similar\056\056 Just like ");
Verbatim("  make mex\012");
PBreak();
Text("This is somewhat optional\054 but ");
Text("I\047d like to stop execution at a certain\012point\056 For instance\054 after all ");
Text("C sources have been generated\056 ");
Text("I can do this\012using a function and an extra command field\056");
Verbatim("   \173compilation linking library\055generation\175 forbid\012");
Text("and");
Verbatim("   \173\044id\175 \173 class \173compilation\175 \175 cmd\056set\012");
Text("would do it\056 ");
Text("Whenever you forbid a class of commands\054 they are removed from\012the command list prior to dependency checking\056 ");
PBreak();
Text("Another nice feature would be a \047make clean\047 option\056\056 i\056e\056");
Verbatim("   jj \055c\012");
Text("removes all files that appear in the output list\056");
PBreak();
Text("I need a way to import gcc\047s \055MMD output\056");
PBreak();
Text("A new feature maybe\056\056 ");
Text("Instead of executing commands or writing them to\012the console\054 we could maybe make a shell script out of commands\056\012This would have some problems with configuration variables but\012maybe ");
Text("I can provide protection for them\056\056\012For instance\072");
Verbatim("   \173 top\056dir \173\044HERE \056\056\057\175\012      protect \173\044LIBS\056fontconfig\175\012      protect \173\044LIBS\056freetype\175\012  \175 script\056set\012");
Text("Really tough stuff but worth consideration\056");
PBreak();
Text("There is no need for protection\056 ");
Text("Instead we can do this\072 ");
Verbatim("  \173 \044LIBS\137FREETYPE \175 env\056set\056forget\012");
Text("This would set the environment variable to the value of the global variable\012\044");
Text("L");
Text("I");
Text("BS\137F");
Text("REETYPE and then remove that variable from the global function table\056\012This way\054 when you execute the command which uses \044");
Text("L");
Text("I");
Text("BS\137F");
Text("REETYPE\054 the shell \012expands it\056 ");
Text("When you print the command instead\054 the variable is not expanded\012and printed as it is\072 \044");
Text("L");
Text("I");
Text("BS\137F");
Text("REETYPE\056 Thus the resulting string can be\012put in a script and a shell can later expand it\056 The variables used in this \012fashion need to be written in a format compatible with the shell \050i\056e\056 no\012funny punctuation in it\051\056");
PBreak();
Text("I need to rename some functions\056 rep\056sfx should really be sfx\056rep\012then maybe ");
Text("I could add sfx\056filter etc\056\056 list\056trans seems a bit strange\056\012maybe list\056tr is better\056 for traverse and translate\056");
PBreak();
Text("OK\056 cool idea\056 if there are unrecognized command line arguments\054 they\012get defined as global variables\056 i\056e\056");
Verbatim("    jj \055debug\012");
Text("would set \044DE");
Text("BUG\075\173yes\175 and");
Verbatim("    jj \055K\0753\012");
Text("would set \044K\075\1733\175\056 ");
Text("Way cool\056 This will also allow me to implement \012environments\056 i\056e\056 think about");
Verbatim("    jj \055win32\012");
Text("or similar\056\056");
PBreak();
