-[program "prgout.c" ]


arg_t *blt_prgout(arg_t *call,frame_t *frame) {
	char *varname;
	varname= get_varname(call,0,"prgout");
	-[ count arguments ]
	-[ allocate space for arguments ]
	-[ prepare arguments ]
	-[ run the command ]
	-[ free the arguments ]
	-[ convert newlines to spaces ]
	var_set(varname, arg_new_text(output), frame);
	free(varname);
	return 0;
}

=[ convert newlines to spaces ] {
	int i;
	for(i=0;output[i];i++)
		if (output[i]=='\n')
			output[i]=' ';
again:
	if (i) {
		i--;
		if (output[i]==' ') {
			output[i]= 0;
			goto again;
		}
	}
}

=[ count arguments ]
	int nargs=0;
	{ arg_t *A;
	-[ for each A in list call, begin]
		nargs++;
	-[ end ]
	nargs--;
	}

=[ allocate space for arguments ]
	char **argv;
	argv= malloc(sizeof(*argv)*(nargs+1));

=[ prepare arguments ] {
	int i=-1;
	arg_t *A;
	-[ for each A in list call, begin ]
		if (i>=0)
			argv[i]= arg_to_string_noforce(A,frame);
		i++;
	-[ end ]
	argv[nargs]= 0;
}

=[ run the command ]
	char *output;
	size_t output_len;
	{ int dummy;
	char *errout;
	size_t errout_len;
	if (proc_run(argv[0], argv, &dummy, 0,0,
		&output, &output_len,
		&errout, &errout_len)) {
			fprintf(stderr,"jj: child %s failed. ",argv[0]);
			fprintf(stderr,"it died with the message:\n%s",errout);
			exit(1);
	}}
	
=[ free the arguments ] {
	int i;
	for(i=0;i<nargs;i++)
		free(argv[i]);
	free(argv);
}

=[]

	




/*
 {$fn} {} {} {} {} {prgout}
 
so..

 {$LIBS.freetype} {pkg-config} {--cflags} {prgout}

*/


-[ header "stdarg.h" ]
-[ lheader "extlibs.h" ]
-[ lheader "parser.h" ]
-[ lheader "table.h" ]
-[ lheader "functions.h" ]
-[ lheader "string.h" ]
-[ header "string.h" ]
-[ header "stdlib.h" ]
-[ header "stdio.h" ]