-[ library "print.c", header "print.h" ]

-[ lheader "parser.h" ]
-[ header "stdio.h" ]


-[public] void
print_stmt(stmt_t* S) {
	arg_t *a;
	-[ private ] int tab;
	printf("%*s",tab," ");
	printf("func <%s>\n",S->func);
	tab+= 3;
	-[ for each a in list (&S->args) , begin ]
		print_arg(a);
	-[ end ]
	tab-=3;
}

-[public] void
print_arg(arg_t *A) {
	token_t *t;
	printf("%*s", tab, " ");
	printf("arg\n");
	tab+= 3;
	-[ for each t in list (&A->tokens) , begin ]
		print_token(t);
	-[ end ]
	tab-= 3;
}

-[public] void 
print_token(token_t *T) {
	printf("%*s", tab, " ");
	printf("token ");
	switch(T->kind) {
		case '{': printf(" {"); break;
		case '}': printf(" }"); break;
		case 'W': printf(" W<%s>",T->data); break;
	}
	printf("\n");
}

-[public] arg_t *
blt_print(arg_t *call, frame_t *F) {
	arg_t *a;
	-[ for each a in list call, begin ]
		print_arg(a);
	-[ end ]
	return 0;
}

-[ lheader "table.h" ]
-[ lheader "functions.h" ]

-[public] arg_t *
blt_dump(arg_t *call, frame_t *F) {
	arg_t *a;
	printf("Dump:\n");
	-[ for each a in list call, begin ]
		token_t *T;
		-[for each T in list (&a->tokens) , begin ]
			if (T->kind!='W')
				continue;
			if (T->data[0]=='$') {
				arg_t *val= var_get(T->data, F);
				if (!val) {
					printf("null (%s)\n",T->data);
				} else {
					print_arg(val);
				}
			} else printf("%s\n", T->data);
		-[ end ]
	-[ end ]
	return 0;
}


