
chomp($TOP_DIR = `pwd`);


$subdirs= "";
$batch_o="";
$batch_e="";

subdir("lib");
subdir("categories");
subdir("simple_search");
subdir("contact");
subdir("personnel");
subdir("main");
subdir("flight");
subdir("training");


recursive_make("csources");
recursive_make("objects");
recursive_make("programs");

open MAKEFILE, ">Makefile";
print(MAKEFILE $makefile_rules);
close MAKEFILE;

open BATCH ,">build.bat";
print BATCH $batch_o;
print BATCH $batch_e;
close BATCH;

sub library_file {
	$FN= $_[0];
	$FT= 'L';

	$sys_app_sources= "";
	$sys_headers= "";
	$lib_app_sources= "";
	$objects= "";
}

sub type1_program {
	$FN= $_[0];
	$FT= '1';

	$sys_app_sources= "";
	$sys_headers= "";
	$lib_app_sources= "";
	$objects= "";
}

sub type2_program {
	$FN= $_[0];
	$FT= '2';

	$sys_app_sources= "";
	$sys_headers= "";
	$lib_app_sources= "";
	$objects= "";
}

sub type3_program {
	$FN= $_[0];
	$FT= '3';

	$sys_app_sources= "";
	$sys_headers= "";
	$lib_app_sources= "";
	$objects= "";
}

sub object {
	$objects= $objects . " " . $_[0];
}

sub sys_appsource {
	$sys_app_sources= $sys_app_sources . " " . $_[0] ;
}

sub lib_appsource {
	$lib_app_sources= $lib_app_sources . " " . $TOP_DIR . "/lib/" . $_[0];
}

sub appsource {
	$lib_app_sources= $lib_app_sources . " " . $_[0];
}

sub sys_header {
	$sys_headers= $sys_headers . " " . $_[0];
}

sub genfile {
	if ($FT eq 'L') {
		generate_libfile();
	} 
	if ($FT eq '1') {
		generate_type1_prg();
	}
	if ($FT eq '2') {
		generate_type2_prg();
	}
	if ($FT eq '3') {
		generate_type3_prg();
	}
}

sub subdir {
	batch_line(sprintf("cd %s\n",$_[0]));
	chdir $_[0];
	my $txt="";
	my $my_makefile_rules= $makefile_rules;
	my $my_c_sources= $c_sources;
	my $my_o_files= $o_files;
	my $my_programs= $programs;

	$subdirs= $subdirs . " " . $_[0];

	$makefile_rules= "";
	$c_sources= "";
	$o_files= "";
	$programs= "";

	my $my_subdirs= $subdirs;
	$subdirs= "";

	open FILESPL, "<files.pl";
	while (<FILESPL>) {
		$txt= $txt . $_;
	}
	close FILESPL;
	eval($txt);
	if ($@ ne "") {
		 die "error in subproc: $@";
	}
	open MAKEFILE,">Makefile";
	if ($c_sources eq "") {
		recursive_make("csources");
	} else {
		printf(MAKEFILE "csources: %s\n", $c_sources);
	}
	if ($o_files eq "") {
		recursive_make("objects");
	} else {
		printf(MAKEFILE "objects:%s\n",$o_files);
	}
	if ($programs eq "") {
		recursive_make("programs");
	} else {
		printf(MAKEFILE "programs:%s\n",$programs);
	}
	print(MAKEFILE $makefile_rules);
	close MAKEFILE;

	$c_sources= $my_c_sources;
	$o_files= $my_o_files;
	$programs= $my_programs;
	$makefile_rules= $my_makefile_rules;
	$subdirs= $my_subdirs;

		chomp($x= `pwd`);
		printf("all done in %s\n",$x);
	chdir "..";
	batch_line("cd ..\n");
}


sub generate_libfile {
	$c_sources = $c_sources . " " . $FN . ".c";
	makefile_rule(
		sprintf("%s.c: %s.w %s\n", $FN, $FN, $lib_app_sources));
	makefile_rule(
		sprintf("\tApp -m `applib template.w %s` \$^\n",
				$sys_app_sources));

	$o_files = $o_files . " " . $FN . ".o";
	my $cflags= convert_headers_to_cflags();
	makefile_rule(
		sprintf("%s.o: %s.c\n", $FN, $FN));
	makefile_rule(
		sprintf("\tgcc -MMD -o %s.o -c %s.c -g -Wall %s\n",$FN,$FN,
				$cflags));

	batch_line_obj(sprintf("gcc -o %s.o -c %s.c -g -Wall %s\n", $FN, $FN,
		convert_headers_to_cflags_win32()));
}

sub makefile_rule {
	$makefile_rules= $makefile_rules . $_[0];
}

sub convert_headers_to_cflags {
	my $cflags= $sys_headers;
	$cflags =~ s/mysql/$MYSQLCFLAGS/;
	return $cflags . " -I$TOP_DIR/lib";
}

sub convert_headers_to_cflags_win32 {
	my $cflags= $sys_headers;
	$cflags =~ s/mysql/$WIN_MYSQLCFLAGS/;
	return $cflags . " -I$WIN_TOP_DIR\\lib";
}

sub recursive_make {
	my $target= $_[0];
	makefile_rule(sprintf("%s:\n",$target));
	my @subs= split(/ +/,$subdirs);
	my $i;
	for($i=0;$i<=$#subs;$i++) {
		if ($subs[$i] ne "") {
		makefile_rule(
			sprintf("\tmake -C %s %s\n",$subs[$i], $target));
		}
	}
}

sub generate_type1_prg {
	$c_sources= $c_sources . "  " . $FN . ".c" ;
	makefile_rule(
	     sprintf("%s.c: %s.w %s/lib/htmlmacros.w %s/lib/db-macros.w %s/lib/ztemplate.w %s\n", 
		$FN, $FN, $TOP_DIR,$TOP_DIR, $TOP_DIR, $lib_app_sources));
	makefile_rule(
	   sprintf("\tApp -m `applib template.w misc.w list.w %s` \$^\n",
				$sys_app_sources));

	$o_files = $o_files . " " . $FN . ".o";
	my $cflags= convert_headers_to_cflags();
	makefile_rule(
	   sprintf("%s.o: %s.c\n", $FN, $FN));
	makefile_rule(
	   sprintf("\tgcc -MMD -o %s.o -c %s.c -g -Wall %s %s\n",$FN,$FN,
	   		$MYSQLCFLAGS,$cflags));

	batch_line_obj(sprintf("gcc -o %s.o -c %s.c -g -Wall %s %s\n", $FN, $FN,
		$WIN_MYSQLCFLAGS, convert_headers_to_cflags_win32()));

	$programs= $programs .  " " . $FN . ".exe" ;
	makefile_rule(
	   sprintf("%s.exe: %s.o %s %s\n", $FN,$FN,$objects,type1_stdobj("L")));
	makefile_rule(
	    sprintf("\tgcc -o \$@ \$^ -g -Wall %s %s\n",
		 $MYSQLLIBS));

	batch_line_exe(
	   sprintf("gcc -o %s.exe %s.o %s %s -g -Wall %s\n",
		$FN, $FN, 
		towin32_path($objects),
		type1_stdobj("W"),$WIN_MYSQLLIBS));
}

sub generate_type2_prg {
	$c_sources= $c_sources . "  " . $FN . ".c" ;
	makefile_rule(
	     sprintf("%s.c: %s.w %s/lib/htmlmacros.w %s/lib/db-macros.w %s/lib/ytemplate.w %s/lib/hparams.w %s\n", 
		$FN, $FN, 
		$TOP_DIR,$TOP_DIR, $TOP_DIR,  $TOP_DIR,
		$lib_app_sources));
	makefile_rule(
	   sprintf("\tApp -m `applib template.w misc.w list.w %s` \$^\n",
				$sys_app_sources));

	$o_files = $o_files . " " . $FN . ".o";
	my $cflags= convert_headers_to_cflags();
	makefile_rule(
	   sprintf("%s.o: %s.c\n", $FN, $FN));
	makefile_rule(
	   sprintf("\tgcc -MMD -o %s.o -c %s.c -g -Wall %s %s\n",$FN,$FN,
	   		$MYSQLCFLAGS,$cflags));

	batch_line_obj(sprintf("gcc -o %s.o -c %s.c -g -Wall %s %s\n", $FN, $FN,
		$WIN_MYSQLCFLAGS, convert_headers_to_cflags_win32()));

	$programs= $programs .  " " . $FN . ".exe" ;
	makefile_rule(
	   sprintf("%s.exe: %s.o %s %s\n", $FN,$FN,$objects,type2_stdobj("L")));
	makefile_rule(
	    sprintf("\tgcc -o \$@ \$^ -g -Wall %s\n", $MYSQLLIBS));

	batch_line_exe(
	   sprintf("gcc -o %s.exe %s.o %s %s -g -Wall %s\n",
		$FN, $FN, 
		towin32_path($objects),
		type2_stdobj("W"),$WIN_MYSQLLIBS));
}

sub generate_type3_prg {
	$c_sources= $c_sources . "  " . $FN . ".c" ;
	makefile_rule(
	     sprintf("%s.c: %s.w %s/lib/htmlmacros.w %s\n", 
		$FN, $FN, 
		$TOP_DIR,
		$lib_app_sources));
	makefile_rule(
	   sprintf("\tApp -m `applib template.w %s` \$^\n",
				$sys_app_sources));

	$o_files = $o_files . " " . $FN . ".o";
	my $cflags= convert_headers_to_cflags();
	makefile_rule(
	   sprintf("%s.o: %s.c\n", $FN, $FN));
	makefile_rule(
	   sprintf("\tgcc -MMD -o %s.o -c %s.c -g -Wall %s\n",$FN,$FN,
	   		$cflags));

	batch_line_obj(sprintf("gcc -o %s.o -c %s.c -g -Wall %s\n", $FN, $FN,
		 convert_headers_to_cflags_win32()));

	$programs= $programs .  " " . $FN . ".exe" ;
	makefile_rule(
	   sprintf("%s.exe: %s.o %s %s\n", $FN,$FN,$objects,type3_stdobj("L")));
	makefile_rule("\tgcc -o \$@ \$^ -g -Wall\n");

	batch_line_exe(
	   sprintf("gcc -o %s.exe %s.o %s %s -g -Wall\n",
		$FN, $FN, 
		towin32_path($objects),
		type3_stdobj("W")));
}

sub batch_line {
	batch_line_obj($_[0]);
	batch_line_exe($_[0]);
}

sub batch_line_obj {
	$batch_o = $batch_o . $_[0];
}

sub batch_line_exe {
	$batch_e = $batch_e . $_[0];
}

sub towin32_path {
	my $pa= $_[0];
	$pa =~ s'/'\\'g;
	return $pa;
}


sub type3_stdobj {
	my $dir;
	if ($_[0] eq "L") {
		$dir= $TOP_DIR .  "/lib/" ;
	} else {
		$dir= $WIN_TOP_DIR .  "\\lib\\" ;
	}
	return $dir . "bpihtml.o "
		. $dir . "stdpages.o ";
}


sub type2_stdobj {
	my $dir;
	if ($_[0] eq "L") {
		$dir= $TOP_DIR .  "/lib/" ;
	} else {
		$dir= $WIN_TOP_DIR .  "\\lib\\" ;
	}
	return $dir   .  "bpihtml.o "
		. $dir . "stdpages.o "
		. $dir . "bpiutils.o "
		. $dir . "bpidb.o "
		. $dir . "bpipparam.o " ;
}

sub type1_stdobj {
	my $dir;
	if ($_[0] eq "L") {
		$dir= $TOP_DIR .  "/lib/" ;
	} else {
		$dir= $WIN_TOP_DIR .  "\\lib\\" ;
	}
	return
		$dir .  "bpihtml.o "
		. $dir . "stdpages.o "
		. $dir . "bpiutils.o "
		. $dir . "bpidb.o " ;
}

