

appgenerate(
	'main.c main.h',
	'main.w modules.w debug.w',
	'template.w condproto.w hereperl.w closure.w'); 



sub appgenerate {
	my ($targets,$sources,$libsources)= @_;
	if (newer($sources,$targets) == 1 ) {
		lsystem( 'App',
			installed_web_sources($libsources),
			strtolist($sources));
	}
}

%macro_libraries={};

sub installed_web_source {
	my $src= $_[0];
	if ($macro_libraries{$src}) {
		return $macro_libraries{$src};
	}
	$macro_libraries{$src}=`applib $src`;
	$macro_libraries{$src} =~ s/ //g;
	return $macro_libraries{$src};
}

sub strtolist {
	my $str= $_[0];
	my @a= split(/ +/,$str);
	my @b = ();
	while($#a>=0) {
		my $v= shift @a;
		if (! ($v =~ /^ *$/)) {
			push @b, ($v);
		}
	}
	return @b;
}

sub lmerge {
	my @r= ();
	while($#_ >= 0 ) {
		my @a= shift ;
		push @r,  @a;
	}
	return @r;
}


sub newer {
	my ($src,$tgt)= @_;
	my @srclist= strtolist($src);
	my @tgtlist= strtolist($tgt);
	my $si,$ti;
	for($si=0;$si<=$#srclist;$si++) {
		for($ti=0;$ti<=$#tgtlist;$ti++) {
			if (file_newer($srclist[$si],$tgtlist[$ti])==1) {
				return 1;
			}
		}
	}
	return 0;
}


sub file_newer {
	my ($a,$b)= @_;
	my @astat= stat($a) || return 1;
	my @bstat= stat($b) || return 1;
	if ($astat[9] > $bstat[9]) {
		return 1;
	} else { 
		return 0;
	}
}


sub lsystem {
	my $prg;
	$prg= shift;
	my @args= lmerge(@_);
	unshift @args,$prg;
	fsystem(@args);
}

sub installed_web_sources {
	my ($sysweb)= @_;
	my @sources= strtolist($sysweb);
	my @ret= ();
	my $i;
	for($i=0;$i<=$#sources;$i++) {
		my $file=installed_web_source($sources[$i]);
		push @ret, ($file);
	}
	return @ret;
}

sub fsystem {
	my @args= @_;
	my $i;
	for($i=0; $i<=$#args;$i++) {
		print $args[$i];
		print " ";
	}
	print "\n";
}
