
-[private] typedef struct {
	char *fn;
	time_t mtime;
} mtime_entry_t;

-[public] time_t get_modtime(char *fn)
{
	time_t T;
	T= modtime(fn);
	if (!T)
		exit(fprintf(stderr,
			"jj: can not get modtime for file %s\n",fn));
	return T;
}

-[public] time_t get_modtime_weak(char *fn) {
	return modtime(fn);
}

-[private] time_t modtime(char *fn) {
	mtime_entry_t *R;
	mtime_entry_t C;
	struct stat sbuf;

	C.fn= fn;
	R= mtimecache_find(modtimes, &C);
	if (R)
		return R->mtime;

	if (stat(fn,&sbuf))
		return 0;

	-[ allocate object R ]
	R->fn= strdup(fn);
	R->mtime= sbuf.st_mtime;
	mtimecache_insert(modtimes, R);
	return R->mtime;
}

-[mtimecache_t : tree of mtime_entry_t* , begin ]
	-[ scope = private ]
	-[ compare ]
		return strcmp(X1->fn,X2->fn);
-[end]

-[private] mtimecache_t *modtimes;

-[private] void modtimes_init() {
	-[ allocate object modtimes ]
	mtimecache_init(modtimes);
}

-[private] time_t get_modtime_force(char *fn)
{
	mtime_entry_t *R;
	mtime_entry_t C;
	struct stat sbuf;

	C.fn= fn;
	R= mtimecache_find(modtimes, &C);
	if (R) {
		mtimecache_remove(modtimes,R);
		free(R->fn);
		free(R);
	}

	if (stat(fn,&sbuf))
		exit(fprintf(stderr,
			"jj: can not get modtime for file %s\n",fn));

	-[ allocate object R ]
	R->fn= strdup(fn);
	R->mtime= sbuf.st_mtime;
	mtimecache_insert(modtimes, R);
	return R->mtime;
}


-[ unused symbol mtimecache_destroy ]

